unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, LCD, ComCtrls, ShowDigit, ShowDOW, Utils,
  CheckLst, ImgList;


Const
    MAJOR_VERSION = 2;
    MINOR_VERSION = 2;

    SX_PIXEL=4; //6-Pixel width
    SY_PIXEL=7; //9-Pixel heigth
    NB_PIXEL_X=12;  //Number of pixel in X
    NB_PIXEL_Y=5;   //Number of pixel in Y
    NB_PIXEL_X_BIG = 8;   //Number of pixel in X for big digit
    NB_PIXEL_Y_BIG = 11;  //Number of pixel in Y for big digit

    NB_WATCH = 10;
    WATCH_NAME: array[1..NB_WATCH] of String = (
        'Analog watch',
        'Vertical binary watch',
        'Big time watch',
        'Horizontal binary watch',
        'Snake watch',
        'Big binary watch',
        'Big analog watch',
        'Dual time zone watch',
        'Dice watch',
        '100th minute watch');


    ADDR_Allocation_size = 0;
    ADDR_Database_Size = 2;
    ADDR_Header_Size =4;
    ADDR_Nb_Record = 5;
    ADDR_Common_Addr =7;

//    NB_PIXEL_X_WEEK=3;  //Number of pixel in X for week
//    NB_PIXEL_Y_WEEK=5;  //Number of pixel in Y for week
//    POS_GT10 = 28;  //Position of the string GT10 in the wristapp


type
  TFByte = File of byte;

  //-- Structure of the PAR file (28 bytes)  --
  TParStruct = Record
    CoreAppSystemDataOffset : Byte;
    NbResTOD : Byte;              // Number of resources required for TOD
    NbResBackup : Byte;           // Number of resources required for Backup
    NbResTimeZoneCheck : Byte;    // Number of resources required for Time zone check
    NbResTimer : Byte;            // Number of resources required for Timer
    NbResStopwatch : Byte;        // Number of resources required for Stopwatch
    NbResSynchroTimer : Byte;     // Number of resources required for Synchro timer
    LcdFlags1 : Byte;             // LCD flags 1
    LcdFlags2 : Byte;             // LCD flags 2
    HeapRequireCode : Word;       // Heap size required for Code
    HeapRequireASD : Word;        // Heap size required for ASD
    HeapRequireADD : Word;        // Heap size required for ADD
    CoreACDEepromApp : Byte;      // Application Configuration Data Byte
    AppType : Byte;               // Application ID type
    AppInstance : Byte;           // Application ID instance number
    ASDaddressOffset : Word;      // ACB : ASD address offset
    ADDaddressOffset : Word;      // ACB : ADD address offset
    StateManagerAddress : Word;   // ACB : App state manager address (Absolute Address)
    BackgroundAddress : Word;     // ACB : App background handler address (Absolute Address)
    BannerMsg : Word;             // ACB : App mode name function address (Absolute Address)
  End;


  //-- Structure of the CODE file --
  TCodeStruct = Record
    Allocation_size : Word;
    Database_Size : Word;
    Header_Size : Byte;
    Nb_Record : Word;
    Common_Addr : Word;
    Common_Size : Word;
    State : Array [0..NB_WATCH+6] of record
      State_Addr : Word;
      State_Size : Word;
    end;
  End;


  TColLcd = Array [0..11] of byte;

  TFrmMain = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Panel2: TPanel;
    ImMainLCDBig: TImage;
    ImDigit0: TImage;
    ImDigit1: TImage;
    ImDigit2: TImage;
    ImDigit3: TImage;
    ImDigit4: TImage;
    ImDigit5: TImage;
    ImDigit6: TImage;
    LbPosBig: TLabel;
    SBCopyBig: TSpeedButton;
    SBPasteBig: TSpeedButton;
    SBUShiftBig: TSpeedButton;
    SBDShiftBig: TSpeedButton;
    SBRShiftBig: TSpeedButton;
    SBLShiftBig: TSpeedButton;
    Label6: TLabel;
    Label7: TLabel;
    SBDRotateBig: TSpeedButton;
    SBLRotateBig: TSpeedButton;
    SBURotateBig: TSpeedButton;
    SBRRotateBig: TSpeedButton;
    ImDigit7: TImage;
    ImDigit8: TImage;
    ImDigit9: TImage;
    LbFile: TLabel;
    PnDigit1: TPanel;
    PnDigit2: TPanel;
    PnDigit3: TPanel;
    PnDigit4: TPanel;
    PnDigit5: TPanel;
    PnDigit6: TPanel;
    PnDigit0: TPanel;
    Memo3: TMemo;
    BtLoadBig: TButton;
    BtSaveBig: TButton;
    PnDigit7: TPanel;
    PnDigit8: TPanel;
    PnDigit9: TPanel;
    BtShowPattern: TButton;
    Panel4: TPanel;
    IMMainLcd: TImage;
    IMSu: TImage;
    IMMo: TImage;
    IMTu: TImage;
    IMWe: TImage;
    IMTh: TImage;
    IMFr: TImage;
    IMSa: TImage;
    LbPos: TLabel;
    SBCopy: TSpeedButton;
    SBPaste: TSpeedButton;
    SBUShift: TSpeedButton;
    SBDShift: TSpeedButton;
    SBRShift: TSpeedButton;
    SBLShift: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    SBDRotate: TSpeedButton;
    SBLRotate: TSpeedButton;
    SBURotate: TSpeedButton;
    SBRRotate: TSpeedButton;
    PnMO: TPanel;
    PnTU: TPanel;
    PnWE: TPanel;
    PnTH: TPanel;
    PnFR: TPanel;
    PnSA: TPanel;
    PnSU: TPanel;
    Memo2: TMemo;
    BtLoad: TButton;
    BtSave: TButton;
    BtShowDOWPattern: TButton;
    Panel1: TPanel;
    Label3: TLabel;
    EdLetterJD: TEdit;
    Panel5: TPanel;
    Label4: TLabel;
    EdLetterWN: TEdit;
    GroupBox1: TGroupBox;
    ImWatchAnalog: TImage;
    ImWatchVerticalBin: TImage;
    ImWatchBigTime: TImage;
    ImWatchHorizontalBin: TImage;
    ImWatchSnake: TImage;
    ImWatchBigBin: TImage;
    ImWatchBigAnalog: TImage;
    ImWatchDualTZone: TImage;
    GroupBox2: TGroupBox;
    CLBWatchType: TCheckListBox;
    GroupBox3: TGroupBox;
    LbFound: TLabel;
    SBSetWristappLoc: TSpeedButton;
    EdWristappLocation: TEdit;
    SBWristUp: TSpeedButton;
    SBWristDown: TSpeedButton;
    BtWrite: TBitBtn;
    BtQuit: TBitBtn;
    GroupBox4: TGroupBox;
    Debug: TMemo;
    ImWatchDice: TImage;
    ImWatch100th: TImage;
    procedure FormShow(Sender: TObject);
    procedure BtWriteClick(Sender: TObject);
    procedure BtQuitClick(Sender: TObject);
    procedure SBSetWristappLocClick(Sender: TObject);
    procedure WristappPresent;
    procedure FormCreate(Sender: TObject);
    procedure ReadWristapp;
    procedure IMMainLcdMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure IMMainLcdMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PnSelClick(Sender: TObject);
    procedure SBPasteClick(Sender: TObject);
    procedure SBCopyClick(Sender: TObject);
    procedure ClipToLCD(lcd:TLcd);
    procedure LCDToClip(lcd:TLcd);
    procedure ClipBigToLCD(lcd:TLcd);
    procedure LCDToClipBig(lcd:TLcd);
    procedure SBLShiftClick(Sender: TObject);
    procedure SBRShiftClick(Sender: TObject);
    procedure SBUShiftClick(Sender: TObject);
    procedure SBDShiftClick(Sender: TObject);
    procedure SBLRotateClick(Sender: TObject);
    procedure SBRRotateClick(Sender: TObject);
    procedure SBURotateClick(Sender: TObject);
    procedure SBDRotateClick(Sender: TObject);
    procedure BtSaveClick(Sender: TObject);
    function  GetLCDCol(lcd:TLcd;col:integer):Integer;
    procedure SetColLCD(lcd:TLcd; col,value:integer);
    procedure BtLoadPatternClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ImMainLCDBigMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImMainLCDBigMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PnSelDigitClick(Sender: TObject);
    procedure SBCopyBigClick(Sender: TObject);
    procedure SBPasteBigClick(Sender: TObject);
    procedure SBLShiftBigClick(Sender: TObject);
    procedure SBUShiftBigClick(Sender: TObject);
    procedure SBDShiftBigClick(Sender: TObject);
    procedure SBRShiftBigClick(Sender: TObject);
    procedure SBLRotateBigClick(Sender: TObject);
    procedure SBRRotateBigClick(Sender: TObject);
    procedure SBURotateBigClick(Sender: TObject);
    procedure SBDRotateBigClick(Sender: TObject);
    procedure BtLoadBigClick(Sender: TObject);
    procedure BtSaveBigClick(Sender: TObject);
    procedure BtShowPatternClick(Sender: TObject);
    procedure EdLetterJDKeyPress(Sender: TObject; var Key: Char);
    procedure EdLetterJDExit(Sender: TObject);
    procedure EdLetterWNExit(Sender: TObject);
    procedure EdLetterWNKeyPress(Sender: TObject; var Key: Char);
    procedure BtShowDOWPatternClick(Sender: TObject);
    procedure CLBWatchTypeClick(Sender: TObject);
    procedure SBWristUpClick(Sender: TObject);
    procedure SBWristDownClick(Sender: TObject);

  private
    { Private declarations }
    oldJD, OldWN : String;
    Function Recherche(fichier,s:string):integer;
    Procedure Msg(s:String); //Display a message in the 'message' box
  public
    { Public declarations }
    AppDir:String;
    ParStruct : TParStruct;
    CodeStruct : TCodeStruct;
    PatternName, fname, BigPatternName : string;
    present : boolean;
    //Tab : Array [1..30] of TColLCD;
    Clip : TColLCD;
    ClipBig : Array [0..7,0..10] of Boolean;
    //LCDWeek : TLCD;
    MainLcd :TLcd;
    MainMem1:TLcd;
    MainMem2:TLcd;
    MainMem3:TLcd;
    MainMem4:TLcd;
    MainMem5:TLcd;
    MainMem6:TLcd;
    MainMem7:TLcd;

    MainLcdBig :TLcd;
    MainMemDigit0:TLcd;
    MainMemDigit1:TLcd;
    MainMemDigit2:TLcd;
    MainMemDigit3:TLcd;
    MainMemDigit4:TLcd;
    MainMemDigit5:TLcd;
    MainMemDigit6:TLcd;
    MainMemDigit7:TLcd;
    MainMemDigit8:TLcd;
    MainMemDigit9:TLcd;

    PnSel:Integer;
    PnSelBig:Integer;
    Modified:Boolean;
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}


//-- Called at the creation of the form --
procedure TFrmMain.FormCreate(Sender: TObject);
var i:integer;
begin
  AppDir:=ExtractFilePath(Application.ExeName);

  //fname:='C:\Program Files\Timex\Data Link USB\App\mywatch_code_018.bin';
  fname:=AppDir+'mywatch_code_018.bin';

  OpenDialog.FileName:=fname;
  PatternName:='';
  BigPatternName:='';
  oldJD:='D';
  OldWN:='W';

  EdWristappLocation.Text:=fname;

  Msg('Hello! Welcome to My Watch configurator V2.20 @ Pierre Delore');
  Msg('');

  MainLCD:=TLcd.Create(Self);
  MainMem1:=TLcd.Create(Self);
  MainMem2:=TLcd.Create(Self);
  MainMem3:=TLcd.Create(Self);
  MainMem4:=TLcd.Create(Self);
  MainMem5:=TLcd.Create(Self);
  MainMem6:=TLcd.Create(Self);
  MainMem7:=TLcd.Create(Self);

  MainLCDBig:=TLcd.Create(Self);
  MainMemDigit0:=TLcd.Create(Self);
  MainMemDigit1:=TLcd.Create(Self);
  MainMemDigit2:=TLcd.Create(Self);
  MainMemDigit3:=TLcd.Create(Self);
  MainMemDigit4:=TLcd.Create(Self);
  MainMemDigit5:=TLcd.Create(Self);
  MainMemDigit6:=TLcd.Create(Self);
  MainMemDigit7:=TLcd.Create(Self);
  MainMemDigit8:=TLcd.Create(Self);
  MainMemDigit9:=TLcd.Create(Self);

//  LCDWeek:=TLcd.Create(Self);

  MainLCD.SetParam(@IMMainLcd,SX_PIXEL*2,SY_PIXEL*2,NB_PIXEL_X,NB_PIXEL_Y);
  MainMem1.SetParam(@IMSu, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem2.SetParam(@IMMo, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem3.SetParam(@IMTu, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem4.SetParam(@IMWe, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem5.SetParam(@IMTh, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem6.SetParam(@IMFr, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);
  MainMem7.SetParam(@IMSa, SX_PIXEL, SY_PIXEL,NB_PIXEL_X, NB_PIXEL_Y);

  MainLCDBig.SetParam(@IMMainLcdBig,SX_PIXEL*2,SY_PIXEL*2,NB_PIXEL_X_BIG,NB_PIXEL_Y_BIG);
  MainMemDigit0.SetParam(@IMDigit0, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit1.SetParam(@IMDigit1, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit2.SetParam(@IMDigit2, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit3.SetParam(@IMDigit3, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit4.SetParam(@IMDigit4, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit5.SetParam(@IMDigit5, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit6.SetParam(@IMDigit6, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit7.SetParam(@IMDigit7, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit8.SetParam(@IMDigit8, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);
  MainMemDigit9.SetParam(@IMDigit9, SX_PIXEL, SY_PIXEL,NB_PIXEL_X_BIG, NB_PIXEL_Y_BIG);

//  LCDWeek.SetParam(@IMWeek, SX_PIXEL*2, SY_PIXEL*2,NB_PIXEL_X_WEEK, NB_PIXEL_Y_WEEK);

  //-- Fill the checkListBox --

  For i:=1 to NB_WATCH do
    CLBWatchType.Items.Add(WATCH_NAME[i]);

  PnSel:=1;
  PnSelBig:=0;
  PnSelClick(PnSU);
  PnSelDigitClick(PnDigit0);
  present:=False;
  modified:=False;
end;

//-- Called when the form is displayed --
procedure TFrmMain.FormShow(Sender: TObject);
begin
  WristappPresent;
  ReadWristapp;
end;

//-- Called before the form is closed --
procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=False;
  If Modified then begin
    If MessageDlg('Patterns not saved !'+#13+#10+'Continue ?', mtConfirmation, [mbNo,mbYes], 0)=mrYes Then CanClose:=True;
  end
  Else CanClose:=True;;
end;

//-- Called when the form is destroyed --
procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  MainLCD.Free;
  MainMem1.Free;
  MainMem2.Free;
  MainMem3.Free;
  MainMem4.Free;
  MainMem5.Free;
  MainMem6.Free;
  MainMem7.Free;
  MainLcdBig.Free;
  MainMemDigit0.Free;
  MainMemDigit1.Free;
  MainMemDigit2.Free;
  MainMemDigit3.Free;
  MainMemDigit4.Free;
  MainMemDigit5.Free;
  MainMemDigit6.Free;
  MainMemDigit7.Free;
  MainMemDigit8.Free;
  MainMemDigit9.Free;
end;


//-- Display a message in the 'message' box --
Procedure TFrmMain.Msg(s:String);
Begin
  Debug.Lines.Add(s);
End;


//-- Read data from the wristapp --
procedure TFrmMain.ReadWristapp;
var f : file of byte;
    b,v : byte;
    i,p,j : Integer;
    s : string;
begin
  //-- Day Of Week reading --
  p:=Recherche(fname,'MW10C'); //Search DOW datas in the common state
  if p<>0 then
  begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+5-1);

      //-- Read Sunday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem1,i,b);
      End;

      //-- Read Monday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem2,i,b);
      End;

      //-- Read Tuesday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem3,i,b);
      End;

      //-- Read Wednesday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem4,i,b);
      End;

      //-- Read Thursday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem5,i,b);
      End;

      //-- Read Friday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem6,i,b);
      End;

      //-- Read Saturday --
      For i:=0 to 11 do
      Begin
        read(f,b);
        SetColLCD(MainMem7,i,b);
      End;

      MainMem1.Display;
      MainMem2.Display;
      MainMem3.Display;
      MainMem4.Display;
      MainMem5.Display;
      MainMem6.Display;
      MainMem7.Display;

      PnSel:=1;
      PnSelClick(PnSU);
    finally
      closefile(f);
    end;
    {$I+}
  end
  else MessageDlg('Unable to open the wristapp or wrong file.', mtError, [mbOK], 0);

  //-- Big digit reading --
  p:=Recherche(fname,'MW10B'); //Search big digit datas in the big digit state
  if p<>0 then
  begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+5-1);

      //-- Read Digit0 - High --
      MainMemDigit0.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit0.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit1 - High --
      MainMemDigit1.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit1.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit 2 - High --
      MainMemDigit2.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit2.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit 3 - High --
      MainMemDigit3.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit3.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit 4 - High --
      MainMemDigit4.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit4.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit 5 - High --
      MainMemDigit5.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit5.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit 6 - High --
      MainMemDigit6.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit6.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit 7 - High --
      MainMemDigit7.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit7.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit8 - High --
      MainMemDigit8.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit8.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit 9 - High --
      MainMemDigit9.Clear;
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=16;
        For j:=4 downto 0 do begin
          if (b and v)<>0 then MainMemDigit9.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit0 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit0.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit1 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit1.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit2 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit2.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit3 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit3.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit4 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit4.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit5 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit5.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit6 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit6.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit7 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit7.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit8 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit8.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      //-- Read Digit9 - Low --
      For i:=0 to 7 do
      Begin
        read(f,b);
        v:=32;
        For j:=10 downto 5 do begin
          if (b and v)<>0 then MainMemDigit9.DirectSetPixel(i,j,True);
          v:=v shr 1;
        End;
      End;

      MainMemDigit0.Display;
      MainMemDigit1.Display;
      MainMemDigit2.Display;
      MainMemDigit3.Display;
      MainMemDigit4.Display;
      MainMemDigit5.Display;
      MainMemDigit6.Display;
      MainMemDigit7.Display;
      MainMemDigit8.Display;
      MainMemDigit9.Display;

      PnSelBig:=0;
      PnSelDigitClick(PnDigit0);
    finally
      closefile(f);
    end;
    {$I+}
  end
  else MessageDlg('Unable to open the wristapp or wrong file.', mtError, [mbOK], 0);


  //-- Julian date letter and week number reading --
  p:=Recherche(fname,'MW10S'); //Search big digit datas in the big digit state
  if p<>0 then
  begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+5-1);

      //-- Read julian date letter --
      read(f,b);
      EdLetterJD.Text:=Byte2sDMChar(b);

      //-- Read week number letter --
      read(f,b);
      EdLetterWN.Text:=Byte2sDMChar(b);

    finally
      closefile(f);
    end;
    {$I+}
  end
  else MessageDlg('Unable to open the wristapp or wrong file.', mtError, [mbOK], 0);

end;


//-- Search datas in a file --
Function TFrmMain.Recherche(fichier,s:string):integer;
Var f:file of byte; //Textfile;
    c,p,l:Integer;
    b:byte;
Begin
  l:=Length(s);
  c:=1;P:=0;
  Recherche:=0;
  If not FileExists(fichier) then exit;
  Assignfile(f,fichier);
  Reset(f);
  while (not eof(f) and (c<l+1)) do begin
    inc(p);
    read(f,b);
    if B=ord(s[c])
      then C:=C+1
      else C:=1;
  End;
  closefile(f);
  if C=l+1
    then Recherche:=P-l+1
    else Recherche:=0;
End;


//-- Write data to the wristapp --
procedure TFrmMain.BtWriteClick(Sender: TObject);
var f : file of byte;
    b, v : byte;
    x,p,y,i,j,k,NbWatch, NbWatchInList, fsize, Pos_End, Pos_Start, NbState, size, StateCmpt,AllocSize  : Integer;
    WatchList:Array [1..NB_WATCH] of integer;
    wsrc,wdst,wstate:Array [0..32767] of byte;
    State : Array[0..25] of record
      num  : word;
      addr : word;
      size : word;
    end;
    s : string;

//.. Sub procedure .............................................................
    //-- Return the watch number from a string --
    function TestWatch(s:String):integer;
    Begin
      TestWatch:=1;
      if (s=WATCH_NAME[1])
        then TestWatch:=1
      else if (s=WATCH_NAME[2])
        then TestWatch:=2
      else if (s=WATCH_NAME[3])
        then TestWatch:=3
      else if (s=WATCH_NAME[4])
        then TestWatch:=4
      else if (s=WATCH_NAME[5])
        then TestWatch:=5
      else if (s=WATCH_NAME[6])
        then TestWatch:=6
      else if (s=WATCH_NAME[7])
        then TestWatch:=7
      else if (s=WATCH_NAME[8])
        then TestWatch:=8
      else if (s=WATCH_NAME[9])
        then TestWatch:=9
      else if (s=WATCH_NAME[10])
        then TestWatch:=10;

    End;


    //-- Read a byte from the file --
    Function ReadByte(Var f):Byte;
    Var b:byte;
    Begin
      read(TFByte(f),b);
      ReadByte:=b;
    End;


    //-- Read a word from the file --
    Function ReadWord(Var f):Word;
    Var b,c:byte;
    Begin
      read(TFByte(f),b);
      read(TFByte(f),c);
      ReadWord:=c*256+b;
    End;

    //-- Write a byte to the file --
    Procedure WriteByte(Var f;b:byte);
    Begin
      write(TFByte(f),b);
    End;


    //-- Read a word from the file --
    Procedure WriteWord(Var f;w:word);
    Var b,c:byte;
    Begin
      b:=w mod 256;
      c:=w div 256;
      write(TFByte(f),b);
      write(TFByte(f),c);
    End;


    //-- Read a word from a byte array --
    Function RWord(s:array of byte; p:integer):word;
    begin
      RWord:=s[p+1]*256+s[p];
    end;

    procedure WWord(var s:array of byte;p:integer;w:word);
    Begin
      s[p]:=w mod 256;
      s[p+1]:=w div 256;
    End;

//.. Start of the procedure ....................................................
begin
  //-- Init the WatchList array --
  For i:=1 to NB_WATCH do
    WatchList[i]:=0;

  //-- Init the destination buffer --
  For i:=0 to 32767 do
    wdst[i]:=0;

  //-- Init some variables --
  NbWatchInList:=CLBWatchType.Count;
  NbWatch:=0;

  //-- Generate the watch list --
  Msg('-- Watch list --');
  for i:=0 to NbWatchInList-1 do begin
    s:=CLBWatchType.Items.Strings[i];
    if CLBWatchType.Checked[i] then begin
      inc(NbWatch);
      j:=TestWatch(s);
      WatchList[NbWatch]:=j;
      Msg(intToStr(j)+' - '+s);
    End;
  end;

  // For debug purpose only
{
  Debug.Lines.Add('nb:'+intToStr(NbWatch));
  For i:=1 to NbWatch do
    Debug.Lines.add(IntToStr(WatchList[i]));
}

  //-- Test no watch is selected --
  If NbWatch=0 then begin
    Msg('[i] No watch selected! The wristapp generation is stopped');
    exit;
  end;

  //-- Read the parameter file --
  assignfile(f,AppDir+'\MyWatch\mywatch_par_018.bin');
  {$I-}
  system.Reset(f);
  Try
    With ParStruct do begin
      CoreAppSystemDataOffset := ReadByte(f);
      NbResTOD := ReadByte(f);
      NbResBackup := ReadByte(f);
      NbResTimeZoneCheck := ReadByte(f);
      NbResTimer := ReadByte(f);
      NbResStopwatch := ReadByte(f);
      NbResSynchroTimer := ReadByte(f);
      LcdFlags1 := ReadByte(f);
      LcdFlags2 := ReadByte(f);
      HeapRequireCode := ReadWord(f);
      HeapRequireASD := ReadWord(f);
      HeapRequireADD := ReadWord(f);
      CoreACDEepromApp := ReadByte(f);
      AppType := ReadByte(f);
      AppInstance := ReadByte(f);
      ASDaddressOffset := ReadWord(f);
      ADDaddressOffset := ReadWord(f);
      StateManagerAddress := ReadWord(f);
      BackgroundAddress := ReadWord(f);
      BannerMsg := ReadWord(f);

      Msg('[i] Parameters file readed');
    End; //With
  Finally
    closefile(f);
  End;
  {$I+}

  //-- Read the code file --
  fsize:=0;
  assignfile(f,AppDir+'\MyWatch\mywatch_code_018.bin');
  {$I-}
  system.Reset(f);
  Try
    while not(eof(f)) do begin
      read(f,wsrc[fsize]);
      inc(fsize);
    end; //While
    Msg('[i] Code file readed. '+intToStr(fSize)+' bytes.');
  Finally
    closefile(f);
  End;
  {$I+}


  msg('Allocation_size ='+ intToStr(RWord(wsrc,ADDR_Allocation_size)));
  msg('Database size   ='+ intToStr(RWord(wsrc,ADDR_Database_Size)));
  msg('Header size     ='+ intToStr(wsrc[ADDR_Header_Size]));

  CodeStruct.Nb_Record:=RWord(wsrc,ADDR_Nb_Record);
  msg('Nb records      ='+ intToStr(CodeStruct.Nb_Record));

  CodeStruct.Common_Addr:=RWord(wsrc,ADDR_Common_Addr);
  msg('Common addr='+ intToStr(CodeStruct.Common_Addr));
  CodeStruct.Common_Size:=RWord(wsrc,CodeStruct.Common_Addr+7);
  msg('Common size='+ intToStr(CodeStruct.Common_Size));


  for i:=0 to CodeStruct.Nb_Record-2 do begin //-2 because we start from 0 and the common state count as one state
    CodeStruct.State[i].State_Addr:=RWord(wsrc,ADDR_Common_Addr+(i*2)+2);
    msg('State '+intToStr(i)+' addr='+ intToStr(CodeStruct.State[i].State_Addr));
    CodeStruct.State[i].State_Size:=RWord(wsrc,CodeStruct.State[i].State_Addr+7);
    msg('State '+intToStr(i)+' size='+ intToStr(CodeStruct.State[i].State_Size));
  end;


  //-- fill the state list --
  // On remplit la liste des states afin de pouvoir crer la liste finale
  // Common state
  State[0].num:=255; //Common
  State[0].size:=CodeStruct.Common_Size;

  // Les states commun a toutes montres
  For i:=0 to 6 do begin
    State[i+1].num:=i;
    State[i+1].size:=CodeStruct.State[i].State_Size;
  end;

  // Les states des montres choisis
  For i:=0 to NbWatch do begin
    State[i+1+7].num:=WatchList[i+1]+7-1; // Vrai numro de state !!
    State[i+1+7].size:=CodeStruct.State[State[i+1+7].num].State_Size;
  End;

  // On calcule le nombre de state total = Common (1) + States commun (7) + States de montre choisis
  NbState:=NbWatch-1+7+1;
  Msg(IntToStr(NbState));

  //-- Offset Calculation (Internal offset) --
  //Gnration de la liste finale des states avec les offsets internes
  j:=(NbState+1)*2;
  For i:=0 to NbState do begin
    State[i].addr:=j;
    j:=j+State[i].size;
  End;

  Msg(Format('Common: Num=%2d Addr=%5d Size=%d',[State[0].num,State[0].Addr,State[0].size]));
  For i:=1 to NbState do
    Msg(Format('State %2d: Num=%2d Addr=%5d Size=%d',[i-1,State[i].num,State[i].Addr,State[i].size]));

  //-- Wristapp generation --

  //Database size
  // On calcule 'Database size'
  j:=State[NbState].Addr+State[NbState].size+7;
  msg('Database size='+IntToStr(j));
  WWord(wDst,ADDR_Database_Size,j);

  //Allocation size
  // On calcule 'Allocation size'. Dpend de database size puisque c'est allocation size au multiple de 64 suivant.
  i:=(((j-1) div 64)+1)*64;
  Msg('Allocation Size ='+IntToStr(i));
  WWord(wDst,ADDR_Allocation_size,i);
  ParStruct.HeapRequireCode:=i;

  //Header size
  // On n'a pas de header dans une wristapp => 2
  wDst[ADDR_Header_Size]:=2;

  //Number of record
  // nombre de state (de 0  x) plus le 'common state'
  WWord(wDst,ADDR_Nb_Record,NbState+1);

  //States address
  // On remplis la table d'adresse des states avec la liste prcdement calcul
  For i:=0 to NbState do
    WWord(wDst,ADDR_Common_Addr+i*2,State[i].Addr);

  StateCmpt:=ADDR_Common_Addr+(NbState*2)+1+1;

  //-- Copy of the common state from wsrc to wDst --
  Pos_Start:=CodeStruct.Common_Addr+7;
  //Size:=State[0].size;
  Size:=CodeStruct.Common_Size;
  // Copy datas
  For i:=0 to Size-1 do begin
    wdst[StateCmpt]:=wsrc[Pos_Start+i];
    Inc(StateCmpt);
  end;
  Msg('Copy of the common state done - Pos_Start:'+IntToStr(Pos_Start)+' Size:'+IntToStr(Size));

  //-- Copy of the state 0 to 6 from wsrc to wDst --
  For j:=1 to 7 do begin
    Pos_Start:=CodeStruct.State[j-1].State_Addr+7;
    //Size:=State[j].size;
    Size:=CodeStruct.State[j-1].State_Size;
    // Copy datas
    For i:=0 to Size-1 do begin
      wDst[StateCmpt]:=wsrc[Pos_Start+i];
      Inc(StateCmpt);
    end;
    Msg('Copy of the state '+intToStr(j-1)+' done - Pos_Start:'+IntToStr(Pos_Start)+' Size:'+IntToStr(Size));
  End;

  //-- Copy of the selected watch states from wSrc to wDst --
  For j:=8 to 8+NbWatch-1 do begin
    //Pos_Start:=State[j].addr+7;
    //Pos_Start:=CodeStruct.State[j-1].State_Addr+7;
    k:=State[j].num;
    Pos_Start:=CodeStruct.State[k].State_Addr+7;
//    Size:=State[j].size;
    //Size:=CodeStruct.State[j-1].State_Size;
    Size:=CodeStruct.State[k].State_Size;
    // Copy datas
    For i:=0 to Size-1 do begin
      wDst[StateCmpt]:=wsrc[Pos_Start+i];
      Inc(StateCmpt);
    end;
    Msg('Copy of the state '+intToStr(j-1)+' done - Pos_Start:'+IntToStr(Pos_Start)+' Size:'+IntToStr(Size));
  End;

  Msg('size ='+IntToStr(StateCmpt+1));

  //-- Generate de APP file --
  //-- Read the parameter file --
  assignfile(f,AppDir+'\mywatch_par_018.bin');
  {$I-}
  system.Rewrite(f);
  Try
    With ParStruct do begin
      WriteByte(f,CoreAppSystemDataOffset);
      WriteByte(f,NbResTOD);
      WriteByte(f,NbResBackup);
      WriteByte(f,NbResTimeZoneCheck);
      WriteByte(f,NbResTimer);
      WriteByte(f,NbResStopwatch);
      WriteByte(f,NbResSynchroTimer);
      WriteByte(f,LcdFlags1);
      WriteByte(f,LcdFlags2);
      WriteWord(f,HeapRequireCode);
      WriteWord(f,HeapRequireASD);
      WriteWord(f,HeapRequireADD);
      WriteByte(f,CoreACDEepromApp);
      WriteByte(f,AppType);
      WriteByte(f,AppInstance);
      WriteWord(f,ASDaddressOffset);
      WriteWord(f,ADDaddressOffset);
      WriteWord(f,StateManagerAddress);
      WriteWord(f,BackgroundAddress);
      WriteWord(f,BannerMsg);

      Msg('[i] Parameters file writed');
    End; //With
  Finally
    closefile(f);
  End;
  {$I+}

  //-- Generate de CODE file --
  //-- Read the code file --
  fsize:=0;
  assignfile(f,AppDir+'\mywatch_code_018.bin');
  {$I-}
  system.ReWrite(f);
  Try
    For i:=0 to ParStruct.HeapRequireCode-1 do
      writeByte(f,wDst[i]);
    Msg('[i] Code file writed. '+intToStr(i)+' bytes.');
  Finally
    closefile(f);
  End;
  {$I+}

  // The wristapp is generate :-)


  //-- Now we modify the generated wristapp ------------------------------------
  if not present then begin
    beep;
    exit;
  end;

  //-- Patch the common part (mwaUtil.asm) --
  // Day of week patterns
  p:=Recherche(fname,'MW10C');
  if p<>0 then
  begin
    assignfile(f,fname);
    {$I-}
    reset(f);
    try
      seek(f,P+5-1);

      //-- Write Sunday --
      For x:=0 to 11 do
      Begin
        b:=GetLCDCol(MainMem1,x);
        Write(f,b);
      End;

      //-- Write Monday --
      For x:=0 to 11 do
      Begin
        b:=GetLCDCol(MainMem2,x);
        Write(f,b);
      End;

      //-- Write Tuesday --
      For x:=0 to 11 do
      Begin
        b:=GetLCDCol(MainMem3,x);
        Write(f,b);
      End;

      //-- Write Wednesday --
      For x:=0 to 11 do
      Begin
        b:=GetLCDCol(MainMem4,x);
        Write(f,b);
      End;

      //-- Write Thursday --
      For x:=0 to 11 do
      Begin
        b:=GetLCDCol(MainMem5,x);
        Write(f,b);
      End;

      //-- Write Friday --
      For x:=0 to 11 do
      Begin
        b:=GetLCDCol(MainMem6,x);
        Write(f,b);
      End;

      //-- Write Saturday --
      For x:=0 to 11 do
      Begin
        b:=GetLCDCol(MainMem7,x);
        Write(f,b);
      End;

    Finally
      closefile(f);
    End;
    {$I+}
    Msg('[i] Common part patched with custom Day of week :-)');
  end;
  //else MessageDlg('Unable to open the wristapp or wrong file', mtError, [mbOK], 0);


  //-- Patch the common part (mwaStart.asm) --
  //-- Julian date letter and week number writing --
  p:=Recherche(fname,'MW10S');
  if p<>0 then
  begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+5-1);

      //-- Write Julian date letter --
      s:=EdLetterJD.Text;
      if s='' then s:='D';
      isDMChar(s[1],p);
      dec(p);
      write(f,byte(p));

      //-- Write Week number letter --
      s:=EdLetterWN.Text;
      if s='' then s:='W';
      isDMChar(s[1],p);
      dec(p);
      write(f,byte(p));


    Finally
      closefile(f);
    End;
    {$I+}
    Msg('[i] Common part patched with custom Julian date letter :-)');
    Msg('[i] Common part patched with custom Week number letter :-)');
  end;
  //else MessageDlg('Unable to open the wristapp or wrong file', mtError, [mbOK], 0);


  //-- Patch the common part (mwaDef.asm) --
  //-- Number of watch and watch order --
  p:=Recherche(fname,'MW10D');
  if p<>0 then
  begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+5-1+2); //+2 because I skip the version number

      //-- Write The number of watch --
      write(f,byte(NbWatch));

    Finally
      closefile(f);
    End;
    {$I+}
    Msg('[i] Common part patched with the number selected watch :-)');
  end;
  //else MessageDlg('Unable to open the wristapp or wrong file', mtError, [mbOK], 0);


  //-- Patch the Big digit state (mwaBig.asm) if exist --

  //-- Big digit writing --
  p:=Recherche(fname,'MW10B'); //Search big digit datas in the big digit state
  if p<>0 then
  begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+5-1);

      //-- Write Digit0 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit0.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit1 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit1.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit2 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit2.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit3 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit3.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit4 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit4.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit5 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit5.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit6 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit6.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit7 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit7.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit8 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit8.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit9 - High --
      For x:=0 to 7 do
      Begin
        v:=16;
        b:=0;
        For y:=4 downto 0 do begin
          if MainMemDigit9.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit0 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit0.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit1 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit1.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit2 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit2.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit3 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit3.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit4 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit4.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit5 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit5.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit6 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit6.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit7 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit7.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit8 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit8.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

      //-- Write Digit9 - Low --
      For x:=0 to 7 do
      Begin
        v:=32;
        b:=0;
        For y:=10 downto 5 do begin
          if MainMemDigit9.DirectGetPixel(x,y) then b:=b or v;
          v:=v shr 1;
        End;
        Write(f,b);
      End;

    Finally
      closefile(f);
    End;
    {$I+}
    Msg('[i] Big digit watch patched :-)');
  end;
  //else MessageDlg('Unable to open the wristapp or wrong file', mtError, [mbOK], 0);


End;


//-- Test if the wristapp is present --
procedure TFrmMain.WristappPresent;
Var P : Integer;
    f : file of byte;
    b,b1 : byte;
Begin
  P:=Recherche(OpenDialog.FileName,'MW10D');
  if P<>0 then begin
    {$I-}
    assignfile(f,fname);
    reset(f);
    try
      seek(f,P+5-1);
      read(f,b); //Read major version number
      read(f,b1); //Read minor version number
    finally
      closefile(f);
    end;
    {$I+}
    if (b=MAJOR_VERSION) and (b1=MINOR_VERSION) then begin
      LbFound.Caption:='Wristapp found : YES';
      fname:=OpenDialog.Filename;
      present:=true;
      Msg('[i] Wristapp found at '+ fname);
    end
    else
      Msg('[!] Wristapp found but it'#39's not the correct version. The wristapp version found is '+Format('%d.%d',[b,b1]));
  end
  else begin
    LbFound.Caption:='Wristapp found : NO';
    present:=false;
    Msg('[!] Wristapp not found press [Set Wristapp location] to select the wrisatpp');
  end;
End;


//-- Called by the Quit button --
procedure TFrmMain.BtQuitClick(Sender: TObject);
begin
  Close;
end;

//-- Called by the "Set wristapp location" button --
procedure TFrmMain.SBSetWristappLocClick(Sender: TObject);
begin
  OpenDialog.FileName:=fname;
  OpenDialog.DefaultExt:='bin';
  OpenDialog.Filter:='bin file (*.bin)|*.bin|all file (*.*)|*.*';
  Opendialog.Execute;
  WristappPresent;
  if present then ReadWristapp;
end;

//## MAIN SCREEN Functions ##

//-- Called if a mouse button is pressed in the Main LCD --
procedure TFrmMain.IMMainLcdMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MainLcd.InvPixel(x,y);
  MainLcd.Display;
  Modified:=True;
end;


//-- Called if the mouse is moved in the main LCD --
procedure TFrmMain.IMMainLcdMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var  tx,ty:integer;
begin
  tx:=MainLCD.GetPositionX(X);
  ty:=MainLCD.GetPositionY(Y);
  LbPos.Caption:=Format('X=%2d  Y=%2d',[tx, ty]);
end;

//## Selection functions ##

//-- Called if a Day label is selected --
procedure TFrmMain.PnSelClick(Sender: TObject);
begin
  PnSU.color:=clBlack;
  PnMO.color:=clBlack;
  PnTU.color:=clBlack;
  PnWE.color:=clBlack;
  PnTH.color:=clBlack;
  PnFR.color:=clBlack;
  PnSA.color:=clBlack;
  TPanel(Sender).color:=clGreen; //clMoneyGreen;

  if Sender=PnSU then
  Begin
    PnSel:=1;
    MainMem1.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem1);
  End
  else if Sender=PnMO then
  Begin
    PnSel:=2;
    MainMem2.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem2);
  End
  else if Sender=PnTU then
  Begin
    PnSel:=3;
    MainMem3.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem3);
  End
  else if Sender=PnWE then
  Begin
    PnSel:=4;
    MainMem4.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem4);
  End
  else if Sender=PnTH then
  Begin
    PnSel:=5;
    MainMem5.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem5);
  End
  else if Sender=PnFR then
  Begin
    PnSel:=6;
    MainMem6.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem6);
  End
  else if Sender=PnSA then
  Begin
    PnSel:=7;
    MainMem7.CopyLcdTo(@MainLcd);
    MainLcd.SetLink(@MainMem7);
  End;
end;


//-- Copy the clip to the LCD
procedure TFrmMain.ClipToLCD(lcd:TLcd);
Var x,y:integer;
    v,w:Byte;
Begin
  For x:=0 to 11 do
  Begin
    v:=Clip[x];
    w:=1;
    For y:=0 to 4 do
    Begin
      if (v and w)<>0 then lcd.DirectSetPixel(x,y,True)
      else lcd.DirectSetPixel(x,y,False);
      w:=w*2;
    End;
  End;
End;


//-- Copy the LCD to the clip --
procedure TFrmMain.LCDToClip(lcd:TLcd);
Var x,y:integer;
    v,w:Byte;
Begin
  For x:=0 to 11 do
  Begin
    v:=0;
    w:=1;
    For y:=0 to 4 do
    Begin
      if lcd.DirectGetPixel(x,y) then v:=v+w;
      w:=w*2;
    End;
    Clip[x]:=v;
  End;
End;


//-- Called if the PASTE button is pressed --
procedure TFrmMain.SBPasteClick(Sender: TObject);
begin
  ClipToLCD(MainLCD);
  ClipToLCD(MainLCD.GetLink^);
  (MainLCD.GetLink^).Display;
  MainLCD.Display;
  Modified:=True;
end;


//-- Called if the COPY button is pressed --
procedure TFrmMain.SBCopyClick(Sender: TObject);
begin
  LCDToClip(MainLCD);
end;


//## MAIN SCREEN Shift ##
procedure TFrmMain.SBLShiftClick(Sender: TObject);
begin
  MainLCD.ShiftLeft(false);
  Modified:=True;
end;


procedure TFrmMain.SBRShiftClick(Sender: TObject);
begin
  MainLCD.ShiftRight(false);
  Modified:=True;
end;


procedure TFrmMain.SBUShiftClick(Sender: TObject);
begin
  MainLCD.ShiftUp(false);
  Modified:=True;
end;


procedure TFrmMain.SBDShiftClick(Sender: TObject);
begin
  MainLCD.ShiftDown(false);
  Modified:=True;
end;


//## MAIN SCREEN Rotate ##
procedure TFrmMain.SBLRotateClick(Sender: TObject);
begin
  MainLCD.ShiftLeft(true);
  Modified:=True;
end;


procedure TFrmMain.SBRRotateClick(Sender: TObject);
begin
  MainLCD.ShiftRight(true);
  Modified:=True;
end;


procedure TFrmMain.SBURotateClick(Sender: TObject);
begin
  MainLCD.ShiftUp(true);
  Modified:=True;
end;


procedure TFrmMain.SBDRotateClick(Sender: TObject);
begin
  MainLCD.ShiftDown(true);
  Modified:=True;
end;


//-- Main screen save pattern --
procedure TFrmMain.BtSaveClick(Sender: TObject);
Var x,y:integer;
    v,w:Byte;
    s:String;
    f:textfile;
begin
  SaveDialog.DefaultExt:='gdw';
  SaveDialog.Filter:='Config file (*.gdw)|*.gdw|all file (*.*)|*.*';
  SaveDialog.FileName:=PatternName;
  If SaveDialog.Execute then Begin
    PatternName:=SaveDialog.Filename;
    Assignfile(f,PatternName);
    {$I-}
    Rewrite(f);
    if IOResult <>0 then
    begin
      MessageDlg('Unable to create "' + PatternName +'"',
        mtInformation, [mbOk], 0);
      CloseFile(f);
    end
    else Begin
      Writeln(f,'GDW2');
      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem1,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem2,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem3,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem4,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem5,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem6,x),2);
      End;
      Writeln(f,s);

      s:='';
      For x:=0 to 11 do
      Begin
        s:=s+IntToHex(GetLCDCol(MainMem7,x),2);
      End;
      Writeln(f,s);

      // Write the week pattern 
      Writeln(f,'000000');

      CloseFile(f);
      Modified:=False;
    End;
    {$I+}
  End;
end;


function TFrmMain.GetLCDCol(lcd:TLcd;col:integer):Integer;
Var y:integer;
    v,w:Byte;
Begin
  v:=0;
  w:=1;
  For y:=0 to 4 do
  Begin
    if lcd.DirectGetPixel(col,y) then v:=v+w;
    w:=w*2;
  End;
  GetLCDCol:=v;
End;


procedure TFrmMain.SetColLCD(lcd:TLcd; col,value:integer);
Var x,y:integer;
    w:Byte;
Begin
  w:=1;
  For y:=0 to 4 do
  Begin
    if (value and w)<>0 then lcd.DirectSetPixel(col,y,True)
    else lcd.DirectSetPixel(col,y,False);
    w:=w*2;
  End;
End;


//-- Main screen load pattern --
procedure TFrmMain.BtLoadPatternClick(Sender: TObject);
Var x,y,version:integer;
    v,w:Byte;
    s,s1:String;
    f:textfile;
begin
  OpenDialog.FileName:=PatternName;
  OpenDialog.DefaultExt:='gdw';
  OpenDialog.Filter:='Config file (*.gdw)|*.gdw|all file (*.*)|*.*';
  If OpenDialog.Execute then Begin
    PatternName:=OpenDialog.Filename;
    Assignfile(f,PatternName);
    {$I-}
    Reset(f);
    if IOResult <>0 then
    begin
      MessageDlg('Unable to open "' + PatternName +'"',
        mtInformation, [mbOk], 0);
      CloseFile(f);
    end
    else Begin
      Version:=1;
      ReadLn(f,s);
      If s='GDW2' then Version:=2;

      If Version=2 then ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem1,x,strtointdef('$'+s1, 0));
      End;
      MainMem1.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem2,x,strtointdef('$'+s1, 0));
      End;
      MainMem2.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem3,x,strtointdef('$'+s1, 0));
      End;
      MainMem3.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem4,x,strtointdef('$'+s1, 0));
      End;
      MainMem4.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem5,x,strtointdef('$'+s1, 0));
      End;
      MainMem5.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem6,x,strtointdef('$'+s1, 0));
      End;
      MainMem6.Display;

      ReadLn(f,s);
      For x:=0 to 11 do
      Begin
        s1:=copy(s,x*2+1,2);
        SetColLCD(MainMem7,x,strtointdef('$'+s1, 0));
      End;
      MainMem7.Display;

{
      If Version=2 then begin
        ReadLn(f,s);
        For x:=0 to 2 do
        Begin
          s1:=copy(s,x*2+1,2);
          SetColLCD(LCDWeek,x,strtointdef('$'+s1, 0));
        End;
        LCDWeek.Display;
      End;
}
      CloseFile(f);

      PnSel:=1;
      PnSelClick(PnSU);
      Modified:=False;
    End;
    {$I+}
  End;
end;



//## MAIN BIG LCD functions ##

//-- Called if a mouse button is pressed in the LCD --
procedure TFrmMain.ImMainLCDBigMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MainLcdBig.InvPixel(x,y);
  MainLcdBig.Display;
  Modified:=True;
end;

//-- Called if the mouse is moved in the LCD --
procedure TFrmMain.ImMainLCDBigMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var  tx,ty:integer;
begin
  tx:=MainLCDBig.GetPositionX(X);
  ty:=MainLCDBig.GetPositionY(Y);
  LbPosBig.Caption:=Format('X=%2d  Y=%2d',[tx, ty]);
end;


procedure TFrmMain.PnSelDigitClick(Sender: TObject);
begin
  PnDigit0.color:=clBlack;
  PnDigit1.color:=clBlack;
  PnDigit2.color:=clBlack;
  PnDigit3.color:=clBlack;
  PnDigit4.color:=clBlack;
  PnDigit5.color:=clBlack;
  PnDigit6.color:=clBlack;
  PnDigit7.color:=clBlack;
  PnDigit8.color:=clBlack;
  PnDigit9.color:=clBlack;
  TPanel(Sender).color:=clGreen; //clMoneyGreen;

  if Sender=PnDigit0 then
  Begin
    PnSelBig:=0;
    MainMemDigit0.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit0);
  End
  else if Sender=PnDigit1 then
  Begin
    PnSelBig:=1;
    MainMemDigit1.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit1);
  End
  else if Sender=PnDigit2 then
  Begin
    PnSelBig:=2;
    MainMemDigit2.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit2);
  End
  else if Sender=PnDigit3 then
  Begin
    PnSelBig:=3;
    MainMemDigit3.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit3);
  End
  else if Sender=PnDigit4 then
  Begin
    PnSelBig:=4;
    MainMemDigit4.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit4);
  End
  else if Sender=PnDigit5 then
  Begin
    PnSelBig:=5;
    MainMemDigit5.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit5);
  End
  else if Sender=PnDigit6 then
  Begin
    PnSelBig:=6;
    MainMemDigit6.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit6);
  End
  else if Sender=PnDigit7 then
  Begin
    PnSelBig:=7;
    MainMemDigit7.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit7);
  End
  else if Sender=PnDigit8 then
  Begin
    PnSelBig:=8;
    MainMemDigit8.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit8);
  End
  else if Sender=PnDigit9 then
  Begin
    PnSelBig:=9;
    MainMemDigit9.CopyLcdTo(@MainLcdBig);
    MainLcdBig.SetLink(@MainMemDigit9);
  End;
end;

procedure TFrmMain.SBCopyBigClick(Sender: TObject);
begin
  LCDToClipBig(MainLcdBig);
end;

procedure TFrmMain.SBPasteBigClick(Sender: TObject);
begin
  ClipBigToLCD(MainLcdBig);
  ClipBigToLCD(MainLcdBig.GetLink^);
  (MainLcdBig.GetLink^).Display;
  MainLcdBig.Display;
  Modified:=True;
end;

//-- Copy the clip (big) to the LCD
procedure TFrmMain.ClipBigToLCD(lcd:TLcd);
Var x,y:integer;
    //v,w:Byte;
Begin
  For x:=0 to 7 do
    For y:=0 to 10 do
    Begin
      if ClipBig[x,y]
        then lcd.DirectSetPixel(x,y,True)
        else lcd.DirectSetPixel(x,y,False);
    End;
End;


//-- Copy the LCD to the clip (big) --
procedure TFrmMain.LCDToClipBig(lcd:TLcd);
Var x,y:integer;
    v,w:Byte;
Begin
  For x:=0 to 7 do
    For y:=0 to 10 do
      ClipBig[x,y]:=lcd.DirectGetPixel(x,y);
End;


procedure TFrmMain.SBLShiftBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftLeft(false);
  Modified:=True;
end;

procedure TFrmMain.SBUShiftBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftUp(false);
  Modified:=True;
end;

procedure TFrmMain.SBDShiftBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftDown(false);
  Modified:=True;
end;

procedure TFrmMain.SBRShiftBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftRight(false);
  Modified:=True;
end;

procedure TFrmMain.SBLRotateBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftLeft(true);
  Modified:=True;
end;

procedure TFrmMain.SBRRotateBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftRight(true);
  Modified:=True;
end;

procedure TFrmMain.SBURotateBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftUp(true);
  Modified:=True;
end;

procedure TFrmMain.SBDRotateBigClick(Sender: TObject);
begin
  MainLcdBig.ShiftDown(true);
  Modified:=True;
end;

procedure TFrmMain.BtLoadBigClick(Sender: TObject);
Var x,y,version:integer;
    v,w:Byte;
    s,s1:String;
    f:textfile;
begin
  OpenDialog.FileName:=PatternName;
  OpenDialog.DefaultExt:='gbd';
  OpenDialog.Filter:='Big digit file (*.gbd)|*.gbd|all file (*.*)|*.*';
  If OpenDialog.Execute then Begin
    BigPatternName:=OpenDialog.Filename;
    LbFile.Caption:='File: '+BigPatternName;
    Assignfile(f,BigPatternName);
    {$I-}
    Reset(f);
    if IOResult <>0 then
    begin
      MessageDlg('Unable to open "' + BigPatternName +'"',
        mtInformation, [mbOk], 0);
      CloseFile(f);
    end
    else Begin
      Version:=1;
      ReadLn(f,s);
      If s='GBD1' then Version:=1;

      //-- Read data for digit 0 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit0.DirectSetPixel(x,y,True)
          else MainMemDigit0.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit0.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 1 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit1.DirectSetPixel(x,y,True)
          else MainMemDigit1.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit1.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 2 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit2.DirectSetPixel(x,y,True)
          else MainMemDigit2.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit2.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 3 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit3.DirectSetPixel(x,y,True)
          else MainMemDigit3.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit3.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 4 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit4.DirectSetPixel(x,y,True)
          else MainMemDigit4.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit4.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 5 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit5.DirectSetPixel(x,y,True)
          else MainMemDigit5.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit5.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 6 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit6.DirectSetPixel(x,y,True)
          else MainMemDigit6.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit6.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 7 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit7.DirectSetPixel(x,y,True)
          else MainMemDigit7.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit7.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 8 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit8.DirectSetPixel(x,y,True)
          else MainMemDigit8.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit8.Display;
      ReadLn(f,s); //Read one empty line

      //-- Read data for digit 9 --
      For y:=0 to 10 do Begin
        Readln(f,s);
        For x:=0 to 7 do
        Begin
          if s[x+1]='#'
          then MainMemDigit9.DirectSetPixel(x,y,True)
          else MainMemDigit9.DirectSetPixel(x,y,False);
        End;
      End;
      MainMemDigit9.Display;
      ReadLn(f,s); //Read one empty line

      CloseFile(f);

      PnSelBig:=0;
      PnSelDigitClick(PnDigit0);
      Modified:=False;
    End;
    {$I+}
  End;
end;


procedure TFrmMain.BtSaveBigClick(Sender: TObject);
Var x,y:integer;
    v,w:Byte;
    s:String;
    f:textfile;
begin
  SaveDialog.FileName:=BigPatternName;
  SaveDialog.DefaultExt:='gbd';
  SaveDialog.Filter:='Big digit file (*.gbd)|*.gbd|all file (*.*)|*.*';
  If SaveDialog.Execute then Begin
    BigPatternName:=SaveDialog.Filename;
    Assignfile(f,BigPatternName);
    {$I-}
    Rewrite(f);
    if IOResult <>0 then
    begin
      MessageDlg('Unable to create "' + PatternName +'"',
        mtInformation, [mbOk], 0);
      CloseFile(f);
    end
    else Begin
      Writeln(f,'GBD1');

      //-- Write data for digit 0 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit0.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 1 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit1.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 2 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit2.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 3 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit3.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 4 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit4.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 5 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit5.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 6 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit6.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 7 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit7.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 8 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit8.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      //-- Write data for digit 9 --
      For y:=0 to 10 do Begin
        S:='';
        For x:=0 to 7 do
        Begin
          if MainMemDigit9.DirectGetPixel(x,y)
          then s:=s+'#'
          else s:=s+'.'
        End;
        Writeln(f,s);
      End;
      Writeln(f,''); //Write one empty line

      CloseFile(f);
      Modified:=False;
    End;
    {$I+}
  End;
End;

procedure TFrmMain.BtShowPatternClick(Sender: TObject);
var x,y:integer;
begin
  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x,y,MainMemDigit0.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+9,y,MainMemDigit1.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+18,y,MainMemDigit2.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+27,y,MainMemDigit3.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+36,y,MainMemDigit4.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+45,y,MainMemDigit5.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+54,y,MainMemDigit6.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+63,y,MainMemDigit7.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+72,y,MainMemDigit8.DirectGetPixel(x,y));

  for x:=0 to 7 do
    for y:=0 to 10 do
      FrmShowDigit.MainLCD.DirectSetPixel(x+81,y,MainMemDigit9.DirectGetPixel(x,y));

  FrmShowDigit.MainLCD.Display;
  //FrmShowDigit.Caption:='Pattern: '+BigPatternName;
  FrmShowDigit.Show;
end;

procedure TFrmMain.EdLetterJDKeyPress(Sender: TObject; var Key: Char);
var p:integer;
begin
  oldJD:=EdLetterJD.Text;
  if key=#8 then exit;
  if not(isDMChar(key, p)) then key:=#0;
end;

procedure TFrmMain.EdLetterJDExit(Sender: TObject);
Var s:String;
    p:integer;
begin
  s:=EdLetterJD.Text;
  if (s='') or not(isDMChar(s[1], p)) then EdLetterJD.Text:=oldJD;
end;


procedure TFrmMain.EdLetterWNExit(Sender: TObject);
Var s:String;
    p:integer;
begin
  s:=EdLetterWN.Text;
  if (s='') or not(isDMChar(s[1], p)) then EdLetterWN.Text:=OldWN;
end;

procedure TFrmMain.EdLetterWNKeyPress(Sender: TObject; var Key: Char);
var p:integer;
begin
  OldWN:=EdLetterWN.Text;
  if key=#8 then exit;
  if not(isDMChar(key, p)) then key:=#0;
end;


procedure TFrmMain.BtShowDOWPatternClick(Sender: TObject);
var x,y:integer;
begin
  for x:=0 to 11 do
    for y:=0 to 4 do
      FrmShowDOW.MainLCD.DirectSetPixel(x,y,MainMem1.DirectGetPixel(x,y));

  for x:=0 to 11 do
    for y:=0 to 4 do
      FrmShowDOW.MainLCD.DirectSetPixel(x+15,y,MainMem2.DirectGetPixel(x,y));

  for x:=0 to 11 do
    for y:=0 to 4 do
      FrmShowDOW.MainLCD.DirectSetPixel(x+30,y,MainMem3.DirectGetPixel(x,y));

  for x:=0 to 11 do
    for y:=0 to 4 do
      FrmShowDOW.MainLCD.DirectSetPixel(x+45,y,MainMem4.DirectGetPixel(x,y));

  for x:=0 to 11 do
    for y:=0 to 4 do
      FrmShowDOW.MainLCD.DirectSetPixel(x+60,y,MainMem5.DirectGetPixel(x,y));

  for x:=0 to 11 do
    for y:=0 to 4 do
      FrmShowDOW.MainLCD.DirectSetPixel(x+75,y,MainMem6.DirectGetPixel(x,y));

  for x:=0 to 11 do
    for y:=0 to 4 do
      FrmShowDOW.MainLCD.DirectSetPixel(x+90,y,MainMem7.DirectGetPixel(x,y));

  FrmShowDOW.MainLCD.Display;
  //FrmShowDigit.Caption:='Pattern: '+BigPatternName;
  FrmShowDOW.Show;
end;


procedure TFrmMain.CLBWatchTypeClick(Sender: TObject);
Var S:String;
begin
  //-- Display the watch image --
  S:=CLBWatchType.Items.Strings[CLBWatchType.ItemIndex];
  ImWatchAnalog.Visible:=(S=WATCH_NAME[1]);
  ImWatchVerticalBin.Visible:=(S=WATCH_NAME[2]);
  ImWatchBigTime.Visible:=(S=WATCH_NAME[3]);
  ImWatchHorizontalBin.Visible:=(S=WATCH_NAME[4]);
  ImWatchSnake.Visible:=(S=WATCH_NAME[5]);
  ImWatchBigBin.Visible:=(S=WATCH_NAME[6]);
  ImWatchBigAnalog.Visible:=(S=WATCH_NAME[7]);
  ImWatchDualTZone.Visible:=(S=WATCH_NAME[8]);
  ImWatchDice.Visible:=(S=WATCH_NAME[9]);
  ImWatch100th.Visible:=(S=WATCH_NAME[10]);
end;


//-- Called by the 'UP' button --
procedure TFrmMain.SBWristUpClick(Sender: TObject);
Var i:integer;
begin
  i:=CLBWatchType.ItemIndex;
  if i>0 then begin
    CLBWatchType.Items.Move(i,i-1);
    CLBWatchType.ItemIndex:=i-1;
  end;
end;


//-- Called by the 'DOWN' button --
procedure TFrmMain.SBWristDownClick(Sender: TObject);
Var i:integer;
begin
  i:=CLBWatchType.ItemIndex;
  if i<CLBWatchType.Count-1 then begin
    CLBWatchType.Items.Move(i,i+1);
    CLBWatchType.ItemIndex:=i+1;
  end;
end;

end.
