unit ShowDigit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,lcd;

Const
    SX_PIXEL=4; //6-Pixel width
    SY_PIXEL=7; //9-Pixel heigth
    NB_PIXEL_X=8;  //Number of pixel in X
    NB_PIXEL_Y=11;   //Number of pixel in Y

type
  TFrmShowDigit = class(TForm)
    ImMain: TImage;
    SaveDialog: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    MainLCD:TLcd;
  end;

var
  FrmShowDigit: TFrmShowDigit;

implementation

{$R *.dfm}

procedure TFrmShowDigit.FormCreate(Sender: TObject);
begin
  MainLCD:=TLcd.Create(Self);
  MainLCD.SetParam(@ImMain, SX_PIXEL, SY_PIXEL,NB_PIXEL_X*10+9, NB_PIXEL_Y);
end;

procedure TFrmShowDigit.FormDestroy(Sender: TObject);
begin
  MainLCD.Free;
end;

procedure TFrmShowDigit.FormKeyPress(Sender: TObject; var Key: Char);
var
  imgWindow: TBitmap;
begin
  if (Key='s') or (key='S') then begin
    imgWindow := TBitmap.Create;
    try
      imgWindow := FrmShowDigit.GetFormImage;
      if SaveDialog.Execute then
        imgWindow.SaveToFile(SaveDialog.FileName);
    finally
      imgWindow.Free;
    end;
  end;
end;

end.
