;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File Name :   mwa.h
; Purpose   :   MyWatch mode application header
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;==============================================================================
;
; STATE REDEFINITIONS
;
;==============================================================================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; BASIC STATE INDEX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CORESTATE0                  EQU 00H     ; Mode Banner State index
CORESTATE1                  EQU 01H     ; Default State index
CORESTATE2                  EQU 02H     ; Set State
CORESTATE3                  EQU 03H     ; Set State n2
CORESTATE4                  EQU 04H     ; Start State
CORESTATE5                  EQU 05H     ; Stop State
CORESTATE6                  EQU 06H     ; Minute rollover State
CORESTATE7                  EQU 07H     
CORESTATE8                  EQU 08H     
CORESTATE9                  EQU 09H     
CORESTATE10                 EQU 0AH
CORESTATE11                 EQU 0BH
CORESTATE12                 EQU 0CH
CORESTATE13                 EQU 0DH
CORESTATE14                 EQU 0EH
CORESTATE15                 EQU 0FH
CORESTATE16                 EQU 10H
CORESTATE17                 EQU 11H
CORESTATE18                 EQU 12H
CORESTATE19                 EQU 13H
CORESTATE20                 EQU 14H


MWABANNERSTATE              equ     COREBANNERSTATE
MWADEFAULTSTATE             equ     COREDEFAULTSTATE
MWASETBANNERSTATE           equ     CORESETBANNERSTATE
MWAYOUROCKSETSTATE          equ     CORESETBANNERSTATE
MWASETSTATE                 equ     CORESETSTATE
MWAPOPUPSTATE               equ     COREPOPUPSTATE
MWAPASSWORDDEFAULTSTATE     equ     COREPASSWORDDEFAULTSTATE
MWAPASSWORDSETBANNERSTATE   equ     COREPASSWORDSETBANNERSTATE
MWAPASSWORDSETSTATE         equ     COREPASSWORDSETSTATE

MWASTARTSTATE               equ     CORESTATE4
MWASTOPSTATE                equ     CORESTATE5

; TODO: Add your own state redefinition here


;==============================================================================
;
; EVENT REDEFINITIONS
;
;==============================================================================

MWA_STATEENTRY              equ     COREEVENT_STATEENTRY
MWA_CROWNHOME               equ     COREEVENT_CROWN_HOME
MWA_CROWNSET                equ     COREEVENT_CROWN_SET1
MWA_CWPULSES                equ     COREEVENT_CW_PULSES
MWA_CCWPULSES               equ     COREEVENT_CCW_PULSES
MWA_MODEDEPRESS             equ     COREEVENT_SWITCH1DEPRESS
MWA_STOPDEPRESS             equ     COREEVENT_SWITCH2DEPRESS
MWA_STARTDEPRESS            equ     COREEVENT_SWITCH3DEPRESS
MWA_UPDATE_TODRES           equ     COREEVENT_DISPLAY_UPDATE_TODRES
MWA_TIMEOUTDONEHIGHRES      equ     COREEVENT_TIMEOUTDONE_HIGHRES

;==============================================================================
;
; HIGH RESOLUTION TIMEOUT DEFINITIONS (Based on 8Hz)
;
;==============================================================================
                                                              
MWAHIRESTO_1P5SECONDS       equ     TIMEOUTHIRES_1P5SEC       
MWAHIRESTO_2SECONDS         equ     TIMEOUTHIRES_2SEC    
MWAHIRESTO_3SECONDS         equ     TIMEOUTHIRES_3SEC  
MWAHIRESTO_4SECONDS         equ     TIMEOUTHIRES_4SEC  
MWAHIRESTO_5SECONDS         equ     TIMEOUTHIRES_5SEC

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
