;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File Name :   mwavars.h
; Purpose   :   MyWatch Application Variable Offsets
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;==============================================================================
;
; MyWatch APPLICATION SYSTEM DATA
;
;==============================================================================

MWASYSTEMDATASTARTOFFSET        equ        0
MWA_ACTIVE_WATCH                equ        00H
MWA_OPTIONS                     equ        01H
    bOPTIONS_TZONE1             equ        00000001B          ; 00 = 00 = Time zone 0
    bOPTIONS_TZONE2             equ        00000010B          ; 01 = 01 = Time zone 1
                                                              ; 10 = 02 = Time zone 2
                                                              ; 11 = 03 = Time zone 3 (not used)  
    bOPTIONS_LOCK               equ        00000100B          ; 0 - Unlock / 1 - Lock the display
    bOPTIONS_SOUND10            equ        00001000B          ; Sound mode: 0 - 15 minutes / 1 - 10 minutes 
    bOPTIONS_SEG_BIGBIN         equ        00010000B          ; Big Binary segment display: 0 - Time / 1 - Date 
    bOPTIONS_RANDOM             equ        00100000B          ; Ramdom watch mode : 0 - No / 1 - Yes
MWA_NBWATCH                     equ        02H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Do not change this variable but change the value if necessary.
; The equate value of this, is the last number from the above variables plus 1
; When you add variables above, be sure to change the value of this too.

MWASYSTEMDATASIZE               equ        3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MWA_OPTIONS_TZONE_MASK          equ        00000011B                  ;Mask for MWA_OPTIONS to get the selected time zone       
MWA_OPTIONS_TZONE_NEGMASK       equ        11111100B                  ;Negative Mask for MWA_OPTIONS to get the selected time zone       


;==============================================================================
;
; MyWatch COMMON VARIABLE REDEFINITIONS
;
;==============================================================================

; TODO: Put here your variables to be use on foreground operation
MWA_Command   equ	(COREForegroundCommonBuffer+0)
;-- "MWA_Command" constate
  CMD_INIT    equ 00
  CMD_NEXT    equ 01
  CMD_PREV    equ 02
  CMD_JUMP    equ 03

MRFSound			equ	(COREForegroundCommonBuffer+1)
; 7: t_hour -		4
;11: t_inter -		3
;14: t_quarter -	5
;19: t_inter -		3
;22: t_minute -		4
;Override the Sound







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; TODO: Put here your variables to be use on background operation





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
