;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File Name :   mwaUtil.asm
; Purpose   :   MyWatch Wrist App Common Utility Routines
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;DO NOT MODIFY THE FOLLOWING SUBROUTINE DEFINITION;;;;;;;;;;;;;;;;;

                IF @DEF('SUBROUTINE')
                    UNDEF SUBROUTINE
                ENDIF
                DEFINE  SUBROUTINE      "'mwautil'"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                GLOBAL  ReadLocalTime
                GLOBAL  dTODSec  
                GLOBAL  dTODMin  
                GLOBAL  dTODHour 
                GLOBAL  dTODDate 
                GLOBAL  dTODMonth
                GLOBAL  dTODYearLo
                GLOBAL  dTODYearHi
                GLOBAL  dTODDow  
                GLOBAL  dTODWeek 
                GLOBAL  DisplayDateInSegment
                GLOBAL  DisplayCustomDOW
                GLOBAL  DisplayLockFlag
                GLOBAL  TestRandomMode
                
;***************************************

;-- Display the custom day of week --
ReadLocalTime:
            		;now, copy hour into our local buffer
            		ld	    A, [COREPTZIndex]
            		ld	    IY, #dTODLocalTimeBuffer
                KTOD_COPY_TIME_FROM_RESOURCE
                LD      A,[COREPTZFormat]
                BIT     A,#bCOREPTZ24HourFormat
                JR      NZ,ReadLocalTimeEnd
                  LD    A,[dTODHour]
                  UTL_CONVERT_TO_12HR_FORMAT
                  LD    [dTODHour],A
ReadLocalTimeEnd:
                ret


;-- Display the date with the year - Date format correspond to the watch setting --
DisplayDateInSegment:
                ;-- Clear the punctuation
                LCD_UPD_DASH1_FLAG OFF
                LCD_UPD_DASH2_FLAG OFF
        
                LCD_UPD_PER1_FLAG OFF
                LCD_UPD_PER2_FLAG OFF

Disp_Year:
                ;LD      HL,#COREPTZFormat
                ;LD      A,[HL]
                LD      A,[COREPTZFormat]
                AND     A,#03
                CP      A,#00   ; D.M.Y
                JR      NZ,Disp1
                    LCD_UPD_PER1_FLAG ON
                    LCD_UPD_PER2_FLAG ON
                    LD      A,[dTODDate]
                    PUSH    A
                    LD      A,[dTODMonth]
                    PUSH    A
                    LD      A,[dTODYearLo]
                    PUSH    A
                    JR      DispD

Disp1:  
                CP      A,#01   ; Y-M-D
                JR      NZ,Disp2
                    LCD_UPD_DASH1_FLAG ON
                    LCD_UPD_DASH2_FLAG ON
                    LD      A,[dTODYearLo]
                    PUSH    A
                    LD      A,[dTODMonth]
                    PUSH    A
                    LD      A,[dTODDate]
                    PUSH    A
                    JR      DispD
        
Disp2:  
                CP      A,#02   ; M-D-Y
                JR      NZ,DispD
                    LCD_UPD_DASH1_FLAG ON
                    LCD_UPD_DASH2_FLAG ON
                    LD      A,[dTODMonth]
                    PUSH    A
                    LD      A,[dTODDate]
                    PUSH    A
                    LD      A,[dTODYearLo]
                    PUSH    A
        
DispD:
                POP     A
                LD      IX, #LCDSEGDIGIT5
                LCD_DISP_2DIG_SEG_DATA_NO_ZERO_SUP
        
                POP     A
                LD      IX, #LCDSEGDIGIT3
                LCD_DISP_2DIG_SEG_DATA_NO_ZERO_SUP
        
                POP     A
                LD      IX, #LCDSEGDIGIT1
                LCD_DISP_2DIG_SEG_DATA_SUP_ZERO_MSD
                
                RET


;-- Display the custom day of week --
DisplayCustomDOW:
                ld      A,[dTODDow]
                ld      L,#12
                mlt
        
                ld      IY,#DayPattern
                add     IY,HL
        
                ld      B, #12
                ld      IX, #0F802H
                UTL_COPY_IYREG_TO_IXREG
                RET


;-- Display the lock flag ---                
DisplayLockFlag:   
                ld      IY, [CORECurrentASDAddress]
                ld      A,[IY+MWA_OPTIONS]
                bit     A,#bOPTIONS_LOCK
                jr      NZ,ExitDisplayLock ;-- Lock                    
                  LCD_UPD_L_FLAG OFF
                  ret  
ExitDisplayLock:
                LCD_UPD_L_FLAG ON  
                ret


;-- Test if random mode ---                
TestRandomMode:   
                ld      IY, [CORECurrentASDAddress]
                ld      A,[IY+MWA_OPTIONS]
                bit     A,#bOPTIONS_RANDOM
                jr      Z,ExitTestRandomMode         
                  ld      B, #CORESTATE6  ;Minute state
                  CORE_REQ_STATE_CHANGE
ExitTestRandomMode:
                ret




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;--- Datas --

;-- Local time buffer --

dTODLocalTimeBuffer:
dTODSec:    db 00 ;second
dTODMin:    db 00 ;minute
dTODHour:   db 00 ;hour
dTODDate:   db 00 ;date
dTODMonth:  db 00 ;month
dTODYearLo: db 00 ;year lo
dTODYearHi: db 00 ;year hi
dTODDow:    db 00 ;dow
dTODWeek:   db 00 ;week number


;-- Label for the configurator --
        db  'M','W','1','0','C'
;-- Day of week pattern
DayPattern:
        db 17H,15H,1DH,00H,1FH,10H,1FH,00H,1FH,02H,04H,1FH  ;Pattern for su
        db 1FH,01H,1FH,00H,1FH,11H,1FH,00H,1FH,02H,04H,1FH  ;Pattern for mo
        db 01H,1FH,01H,00H,1FH,10H,1FH,00H,1FH,15H,15H,00H  ;Pattern for tu
        db 1FH,18H,1FH,00H,1FH,15H,15H,00H,1FH,11H,11H,0EH  ;Pattern for we
        db 01H,1FH,01H,00H,1FH,04H,1FH,00H,1FH,10H,1FH,00H  ;Pattern for th
        db 1FH,05H,05H,00H,1FH,05H,05H,1AH,00H,11H,1FH,11H  ;Pattern for fr
        db 17H,15H,1DH,00H,1FH,05H,1FH,00H,01H,1FH,01H,00H  ;Pattern for sa

